### Persefone.jl - a model of agricultural landscapes and ecosystems in Europe.
###
### These are the tests for the crop growth models.
###

const TESTPARAM_ALMASS = joinpath(pkgdir(Persefone), "test", "test_parameters_almass.toml")
const TESTPARAM_SIMPLECROP = joinpath(pkgdir(Persefone), "test", "test_parameters_simplecrop.toml")

#"Model initialisation" begin
@testset for paramfile in (TESTPARAM_ALMASS, TESTPARAM_SIMPLECROP)
    @testset "Model initialisation" begin
        model = initialise(paramfile)
        @test model isa AgricultureModel
    end
    @testset "Time step" begin
        model = initialise(paramfile)
        stepsimulation!(model)
        @test model isa AgricultureModel
    end
end

